#include <afxwin.h>
#include "SMDialog.h"
#include "resource.h"

afx_msg void SMDialog::OnOK() {
	if(job==NULL) job = new MatchingJob();

	CEdit * runsbox = (CEdit *) (GetDlgItem(IDC_NUMRUNS));
	CEdit * pattern_length_box = (CEdit *) (GetDlgItem(IDC_EDIT_PATTERN_LENGTH));
	CEdit * pattern_box = (CEdit *) (GetDlgItem(IDC_EDIT_PATTERN));
	CEdit * binary_text_box = (CEdit *) (GetDlgItem(IDC_BINARY_TEXT_LENGTH));
    
	char text[8];
	runsbox->GetWindowText(text,8);
	job->num_runs = atoi(text);
	if(job->num_runs<1||job->num_runs>10) {
		MessageBox("Please enter a number between 1 and 10",
				   "Number of runs",
				   MB_ICONWARNING);
		return;
	}

    if(GetCheckedRadioButton(IDC_MODEBINARY,IDC_MODENATURAL)==IDC_MODENATURAL)
		job->mode = MODE_NATURAL;
	else
		job->mode = MODE_BINARY;

	switch(job->mode) {
	case MODE_NATURAL:
		// job->text field setup
		switch(GetCheckedRadioButton(IDC_TEXT_RELNOTES,IDC_TEXT_USER)) {
		case IDC_TEXT_RELNOTES:
			job->text = TEXT_RELNOTES;
			break;
		case IDC_TEXT_REDHAT:
			job->text = TEXT_REDHAT;
			break;
		case IDC_TEXT_EULA:
			job->text = TEXT_EULA;
			break;
		case IDC_TEXT_DICTIONARY:
			job->text = TEXT_DICTIONARY;
			break;
		case IDC_TEXT_USER:
			job->text = TEXT_USER;
			break;
		default:
			MessageBox("Select text source",NULL,MB_ICONWARNING);
			return;
		}

		// job->pattern_size setup
		if(GetCheckedRadioButton(IDC_PATTERN_NUMERIC,IDC_PATTERN_DEFINED)==IDC_PATTERN_NUMERIC) {
			// numeric length
			pattern_length_box->GetWindowText(text,8);
			job->pattern_size = atoi(text);
			if(job->pattern_size<1||job->pattern_size>256) {
				MessageBox("Please enter a value between 1 and 256",
						   "Pattern Size",MB_ICONWARNING);
				return;
			}
		} else {
			// user-defined text
			if(pattern_box->GetWindowTextLength()==0) {
				MessageBox("Please enter a pattern",
							"Pattern definition",MB_ICONWARNING);
				return;
			}
			job->pattern = new char[256];
			for(int i=0;i<256;i++) job->pattern[i] = NULL;
			pattern_box->GetWindowText(job->pattern,256);
			job->pattern_size = PATTERN_USER_DEFINED;
			
		}

		break;
	case MODE_BINARY:
		// text setup
		binary_text_box->GetWindowText(text,8);
		job->text = atoi(text);
		if(job->text<256||job->text>65536) {
			MessageBox("Please enter a number between 256 and 65536",
					"Binary text size",MB_ICONWARNING);
			return;
		}

		//pattern setup
		pattern_length_box->GetWindowText(text,8);
		job->pattern_size = atoi(text);
		if(job->pattern_size<1||job->pattern_size>256) {
			MessageBox("Please enter a value between 1 and 256",
					   "Pattern Size",MB_ICONWARNING);
			return;
		}
		break;
	}

	EndDialog(0);
}

afx_msg void SMDialog::OnCancel() {
	job = NULL;
	EndDialog(-1);
}

MatchingJob * SMDialog::getJob() {
	return job;
}

afx_msg BOOL SMDialog::OnInitDialog() {
	CDialog::OnInitDialog();
	
	job = NULL;

	CEdit * runsbox = (CEdit *) (GetDlgItem(IDC_NUMRUNS));
	CEdit * pattern_length_box = (CEdit *) (GetDlgItem(IDC_EDIT_PATTERN_LENGTH));
	CEdit * pattern_box = (CEdit *) (GetDlgItem(IDC_EDIT_PATTERN));
	CEdit * binary_text_box = (CEdit *) (GetDlgItem(IDC_BINARY_TEXT_LENGTH));

	runsbox->SetWindowText("1");
	pattern_length_box->SetWindowText("20");
	pattern_box->SetWindowText("Natural Mode Only");
	binary_text_box->SetWindowText("5000");

	CheckRadioButton(IDC_MODEBINARY,IDC_MODENATURAL,IDC_MODEBINARY);
	CheckRadioButton(IDC_TEXT_RELNOTES,IDC_TEXT_USER,IDC_TEXT_RELNOTES);
	CheckRadioButton(IDC_PATTERN_NUMERIC,IDC_PATTERN_DEFINED,IDC_PATTERN_DEFINED);

	return TRUE;
}

BEGIN_MESSAGE_MAP( SMDialog, CDialog ) 
	ON_COMMAND( IDOK, OnOK )
	ON_COMMAND( IDCANCEL, OnCancel )
END_MESSAGE_MAP()